#include "MGrammar/ActionTransInfo.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ActionTransInfo.java#1 $
 */

/**
 * This class contains information about how an action
 * was translated (using the AST conversion rules).
 */
MGrammar_ActionTransInfo::MGrammar_ActionTransInfo()
   : assignToRoot_(false)	// somebody did a "#rule = "

{
}

MLANG_String MGrammar_ActionTransInfo::toString() const

{
   return MLANG_String("assignToRoot:") + MLANG_String::valueOf(assignToRoot_) + ", refRuleRoot:"
	+ refRuleRoot_ + ", FOLLOW Set:" + followSetName_;
}

MGrammar_ActionTransInfo::~MGrammar_ActionTransInfo()

{
}
