#ifndef __MGRAMMAR_ACTIONTRANSINFO_H__
#define __MGRAMMAR_ACTIONTRANSINFO_H__
#include "MLANG/String.h"

class MGrammar_ActionTransInfo;
typedef class MGrammar_ActionTransInfo *MGrammar_ActionTransInfo_ptr;
typedef class MGrammar_ActionTransInfo *MGrammar_ActionTransInfo_var;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ActionTransInfo.java#1 $
 */

/**
 * This class contains information about how an action
 * was translated (using the AST conversion rules).
 */
class MGrammar_ActionTransInfo

{
public:
    MGrammar_ActionTransInfo();
    virtual ~MGrammar_ActionTransInfo();
public:
    bool assignToRoot_;	// somebody did a "#rule = "
    MLANG_String refRuleRoot_;		// somebody referenced #rule; string is translated var
    MLANG_String followSetName_;		// somebody referenced $FOLLOW; string is the name of the lookahead set
public:
    MLANG_String toString() const;
};

#endif /* __MGRAMMAR_ACTIONTRANSINFO_H__ */
