#include "MLANG/String.h"
#include "MGrammar/CppBlockFinishingInfo.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CppBlockFinishingInfo.java#1 $
 */

// C++ code generator by Pete Wells: pete@yamuna.demon.co.uk

MGrammar_CppBlockFinishingInfo::MGrammar_CppBlockFinishingInfo()
   : generatedSwitch(false),
     generatedAnIf(false),
     closingBracesOfIFSequence(0),
     needAnErrorClause(true)

{
}

MGrammar_CppBlockFinishingInfo::MGrammar_CppBlockFinishingInfo (
   const MGrammar_CppBlockFinishingInfo& b
) :
   postscript(b.postscript),
   generatedSwitch(b.generatedSwitch),
   generatedAnIf(b.generatedAnIf),
   closingBracesOfIFSequence(b.closingBracesOfIFSequence),
   needAnErrorClause(b.needAnErrorClause)

{
}

MGrammar_CppBlockFinishingInfo::MGrammar_CppBlockFinishingInfo (
   const MLANG_String& ps, 
   bool genS,
   bool genAnIf,
   bool n,
   int closing
) : postscript(ps),
    generatedSwitch(genS),
    generatedAnIf(genAnIf),
    closingBracesOfIFSequence(closing),
    needAnErrorClause(n)

{
}

MGrammar_CppBlockFinishingInfo& MGrammar_CppBlockFinishingInfo::operator= (
   const MGrammar_CppBlockFinishingInfo& b
)

{
   if (this != &b)
    {
      postscript = b.postscript;
      generatedSwitch = b.generatedSwitch;
      generatedAnIf = b.generatedAnIf;
      closingBracesOfIFSequence = b.closingBracesOfIFSequence;
      needAnErrorClause = b.needAnErrorClause;
    }
   return *this;
}

MGrammar_CppBlockFinishingInfo::~MGrammar_CppBlockFinishingInfo ()

{
}
