#ifndef __MPARSER_FILECOPYEXCEPTION_H__
#define __MPARSER_FILECOPYEXCEPTION_H__
#include "MLANG/String.h"
#include "MIO/IOException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/FileCopyException.java#1 $
 */

class MParser_FileCopyException : public MIO_IOException

{
public:
   typedef MIO_IOException super;
public:
   MParser_FileCopyException (const MLANG_String msg)
     : super(msg)
   {
   }
   virtual ~MParser_FileCopyException () {}
};

#endif /* __MPARSER_FILECOPYEXCEPTION_H__ */
