#include "MGrammar/GrammarElement.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/GrammarElement.java#1 $
 */

MGrammar_GrammarElement::MGrammar_GrammarElement (
   MGrammar_Grammar_ptr g,
   int line,
   int column
) : grammar_(g),
    line_(line),
    column_(column)

{
}

MGrammar_GrammarElement::MGrammar_GrammarElement (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& start
) : grammar_(g),
    line_(start->getLine()),
    column_(start->getColumn())

{
}

void MGrammar_GrammarElement::generate()

{
}

MGrammar_Lookahead MGrammar_GrammarElement::look (int )

{
   MGrammar_Lookahead p;
   p.set_null();
   return p;
}

MGrammar_GrammarElement::~MGrammar_GrammarElement()

{
}
