#include "MIO/FileInputStream.h"
#include "MIO/FileReader.h"

MIO_FileReader::MIO_FileReader (
   const MIO_File_var& file
) : MIO_InputStreamReader (new MIO_FileInputStream(file))

{
}

MIO_FileReader::MIO_FileReader (
   const MLANG_String& filename
) : MIO_InputStreamReader (new MIO_FileInputStream(filename))

{
}

MIO_FileReader::~MIO_FileReader ()

{
}
