//$Id: Any.cpp,v 1.3 2004/10/12 12:56:37 roiser Exp $
#include "MLANG/String.h"
#include "Reflection/Any.h"

using namespace MLANG_Reflection;

//-------------------------------------------------------------------------------
std::ostream & MLANG_Reflection::operator << ( std::ostream& o, 
                                           const Any& any) {
//-------------------------------------------------------------------------------
  if      ( any.type() == typeid(char) )   o << any_cast<char>(any);
  else if ( any.type() == typeid(int) )    o << any_cast<int>(any);
  else if ( any.type() == typeid(short) )  o << any_cast<short>(any);
  else if ( any.type() == typeid(long) )   o << any_cast<long>(any);
  else if ( any.type() == typeid(float) )  o << any_cast<float>(any);
  else if ( any.type() == typeid(double) ) o << any_cast<double>(any);
  else if ( any.type() == typeid(const char*) ) o << any_cast<const char*>(any);
  else if ( any.type() == typeid(MLANG_String) ) o << any_cast<MLANG_String>(any);
  else o << "Any object at " << std::hex << &static_cast<Any::holder<int>*>(any.content)->held;
  return o;
}
