//$Id: Enum.cpp,v 1.4 2004/11/30 22:57:58 roiser Exp $


#include "MLANG/Reflection/Enum.h"
#include "MLANG/Reflection/Tools.h"
#include <sstream>


//-------------------------------------------------------------------------------
MLANG_Reflection::Enum::Enum( const char * type,
                          size_t size,
                          const std::type_info & typeInfo )
//-------------------------------------------------------------------------------
  : TypeBase( type, size, ENUM, typeInfo ), 
    m_enums(std::vector<EnumInfo*>()) {}


//-------------------------------------------------------------------------------
MLANG_Reflection::Enum::~Enum() {
//-------------------------------------------------------------------------------
  for (size_t i = 0; i < m_enums.size(); ++i) delete m_enums[ i ];
}
