//$Id: PointerToMember.cpp,v 1.4 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/PointerToMember.h"


//-------------------------------------------------------------------------------
MLANG_Reflection::PointerToMember::PointerToMember( const char * type,
                                                size_t size,
                                                const std::type_info& typeInfo,
                                                const Type & pointerToMemberType) 
//------------------------------------------------------------------------------- 
 : TypeBase( type, size, POINTERTOMEMBER, typeInfo ),
    m_pointerToMemberType( pointerToMemberType ) {}



//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::PointerToMember::fullName( bool typedefexp ) const { 
//-------------------------------------------------------------------------------
  MLANG_String s = "";
  if ( toType().isConst()) { s += "const "; }
  if ( toType().isVolatile()) { s += "volatile "; }
  return m_pointerToMemberType.fullName(typedefexp) + s + "* ";
}
