//$Id: PropertyList.cpp,v 1.4 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/PropertyList.h"
#if !defined(WIN32)
#include <sstream>
#endif /* !WIN32 */

MLANG_Reflection::PropertyList MLANG_Reflection::PropertyList::__NOPROPERTYLIST__ = MLANG_Reflection::PropertyList::PropertyList();

#if 0
//-------------------------------------------------------------------------------
std::ostream & MLANG_Reflection::operator<<( std::ostream & s, 
                                         const PropertyList & p ) {
//-------------------------------------------------------------------------------
  if ( p.m_properties ) {
    for ( PropertyList::Properties::const_iterator pIter = p.m_properties->begin();
          pIter != p.m_properties->end(); ++pIter) {
      s << pIter->first << " : " << pIter->second << std::endl;
    }
  }
  return s;
}
#endif /* !WIN32 */

//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::PropertyList::propertyKeys() const {
//-------------------------------------------------------------------------------
  MLANG_String s = "";
  if ( m_properties ) {
    for(Properties::const_iterator pIter = m_properties->begin(); 
        pIter != m_properties->end(); ) {
      s += pIter->first;
      if (++pIter != m_properties->end() ) { s += ", "; }
    }
  }
  return s;
}

//-------------------------------------------------------------------------------
MLANG_String 
MLANG_Reflection::PropertyList::propertyAsString( const MLANG_String & key ) const 

{
//-------------------------------------------------------------------------------
#if 0
  if ( m_properties ) 
   {
     std::ostringstream o;
     o << (*m_properties)[ key ];
     return o.str().c_str();
   }
#else
  assert(0);
#endif
  return "";
}


