//$Id: Reference.cpp,v 1.5 2004/10/12 12:56:38 roiser Exp $

#include "Reflection/Reference.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Reference::Reference( const Type * referencetype,
                                    const std::type_info& typeInfo )
//-------------------------------------------------------------------------------
  : TypeBase( buildTypeName(referencetype).c_str(), sizeof(int&), REFERENCE, typeInfo ),
    m_referenceType( referencetype ) { }

//-------------------------------------------------------------------------------
MLANG_Reflection::Reference::~Reference() {
//-------------------------------------------------------------------------------
}

//-------------------------------------------------------------------------------
inline MLANG_String 
MLANG_Reflection::Reference::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  return m_referenceType->fullName( typedefexp ) + "&";
}

//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Reference::buildTypeName( const Type* referenceType ) {
//-------------------------------------------------------------------------------
  return referenceType->name() + "&";
}
