//$Id: Reflection.h,v 1.6 2004/12/01 14:49:54 mato Exp $

#ifndef SEAL_REFLECT_REFLEX
#define SEAL_REFLECT_REFLEX

#include "MLANG/Reflection/Kernel.h"
#include "MLANG/Reflection/PropertyList.h"

#include "MLANG/Reflection/Type.h"
#include "MLANG/Reflection/TypeName.h"
#include "MLANG/Reflection/TypeBase.h"

#include "MLANG/Reflection/Array.h"
#include "MLANG/Reflection/Function.h"
#include "MLANG/Reflection/Fundamental.h"
#include "MLANG/Reflection/Pointer.h"
#include "MLANG/Reflection/PointerToMember.h"
#include "MLANG/Reflection/Typedef.h"
#include "MLANG/Reflection/Enum.h"
#include "MLANG/Reflection/EnumInfo.h"
#include "MLANG/Reflection/Union.h"
#include "MLANG/Reflection/UnionInfo.h"

#include "MLANG/Reflection/Base.h"
#include "MLANG/Reflection/Class.h"

#include "MLANG/Reflection/Scope.h"
#include "MLANG/Reflection/ScopeName.h"
#include "MLANG/Reflection/ScopeBase.h"

#include "MLANG/Reflection/Namespace.h"

#include "MLANG/Reflection/Member.h"
#include "MLANG/Reflection/DataMember.h"
#include "MLANG/Reflection/FunctionMember.h"

#include "MLANG/Reflection/TemplateFamily.h"
#include "MLANG/Reflection/InstantiatedTemplate.h"
#include "MLANG/Reflection/InstantiatedTemplateClass.h"
#include "MLANG/Reflection/InstantiatedTemplateFunction.h"

#include "MLANG/Reflection/Object.h"
#include "MLANG/Reflection/Callback.h"


/** \defgroup Ref Reflex */

#endif // SEAL_REFLECT_REFLEX
