//$Id: TypeBuilder.h,v 1.10 2004/11/30 22:57:58 roiser Exp $

#ifndef SEAL_REFLECT_TYPEBUILDER_H
#define SEAL_REFLECT_TYPEBUILDER_H

// Include files
#include "MLANG/Reflection/Type.h"
#include "MLANG/Reflection/Tools.h"

#include <vector>

#if defined(__ICC)
#define OffsetOf(c1,mem) (int(&(((c1*)0)->mem)))
#define OffsetOf2(c1,c2,mem) (int(&(((c1,c2*)0)->mem)))
#define OffsetOf3(c1,c2,c3,mem) (int(&(((c1,c2,c3*)0)->mem)))
#define OffsetOf4(c1,c2,c3,c4,mem) (int(&(((c1,c2,c3,c4*)0)->mem)))
#define OffsetOf5(c1,c2,c3,c4,c5,mem) (int(&(((c1,c2,c3,c4,c5*)0)->mem)))
#define OffsetOf6(c1,c2,c3,c4,c5,c6,mem) (int(&(((c1,c2,c3,c4,c5,c6*)0)->mem)))
#define OffsetOf7(c1,c2,c3,c4,c5,c6,c7,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7*)0)->mem)))
#define OffsetOf8(c1,c2,c3,c4,c5,c6,c7,c8,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8*)0)->mem)))
#define OffsetOf9(c1,c2,c3,c4,c5,c6,c7,c8,c9,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9*)0)->mem)))
#define OffsetOf10(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10*)0)->mem)))
#define OffsetOf11(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11*)0)->mem)))
#define OffsetOf12(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12*)0)->mem)))
#define OffsetOf13(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13*)0)->mem)))
#define OffsetOf14(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14*)0)->mem)))
#define OffsetOf15(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15*)0)->mem)))
#define OffsetOf16(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,mem) (int(&(((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16*)0)->mem)))
#else
#define OffsetOf(c1,mem) ((size_t)(&((c1*)64)->mem)-64)
#define OffsetOf2(c1,c2,mem) ((size_t)(&((c1,c2*)64)->mem)-64)
#define OffsetOf3(c1,c2,c3,mem) ((size_t)(&((c1,c2,c3*)64)->mem)-64)
#define OffsetOf4(c1,c2,c3,c4,mem) ((size_t)(&((c1,c2,c3,c4*)64)->mem)-64)
#define OffsetOf5(c1,c2,c3,c4,c5,mem) ((size_t)(&((c1,c2,c3,c4,c5*)64)->mem)-64)
#define OffsetOf6(c1,c2,c3,c4,c5,c6,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6*)64)->mem)-64)
#define OffsetOf7(c1,c2,c3,c4,c5,c6,c7,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7*)64)->mem)-64)
#define OffsetOf8(c1,c2,c3,c4,c5,c6,c7,c8,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8*)64)->mem)-64)
#define OffsetOf9(c1,c2,c3,c4,c5,c6,c7,c8,c9,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9*)64)->mem)-64)
#define OffsetOf10(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10*)64)->mem)-64)
#define OffsetOf11(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11*)64)->mem)-64)
#define OffsetOf12(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12*)64)->mem)-64)
#define OffsetOf13(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13*)64)->mem)-64)
#define OffsetOf14(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14*)64)->mem)-64)
#define OffsetOf15(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15*)64)->mem)-64)
#define OffsetOf16(c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,mem) ((size_t)(&((c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16*)64)->mem)-64)
#endif

namespace MLANG_Reflection
{ 

    Type TypeBuilder(const char * n);


    Type ConstBuilder(const Type & t);


    Type VolatileBuilder(const Type & t);


    Type PointerBuilder(const Type & t);


    Type ReferenceBuilder(const Type & t);


    Type ArrayBuilder(const Type & t, 
                      size_t n);
  

    Type TypedefTypeBuilder(const char * name, 
                            const Type & t);


    Type FunctionTypeBuilder(const Type & r);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10);

  
    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10, 
                             const Type & t11);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10, 
                             const Type & t11,
                             const Type & t12);
  

    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10, 
                             const Type & t11,
                             const Type & t12, 
                             const Type & t13);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10, 
                             const Type & t11,
                             const Type & t12, 
                             const Type & t13, 
                             const Type & t14);


    Type FunctionTypeBuilder(const Type & r, 
                             const Type & t0, 
                             const Type & t1, 
                             const Type & t2, 
                             const Type & t3,
                             const Type & t4, 
                             const Type & t5, 
                             const Type & t6, 
                             const Type & t7,
                             const Type & t8, 
                             const Type & t9, 
                             const Type & t10, 
                             const Type & t11,
                             const Type & t12, 
                             const Type & t13, 
                             const Type & t14, 
                             const Type & t15);
  

    /**
     * offsetOf will calculate the offset of a data member relative
     * to the start of the class
     * @param member the pointer to the data member
     * @return the offset of the data member
     */
    template < typename C, typename M >
      size_t offsetOf( M C::* member )  {
      return (size_t) & (((C*)0)->*member); 
    }


    /**
     * @struct BaseOffset provide the static function that calculates the offset between 
     * base classes
     */
    template < typename C, typename B >
      struct baseOffset {
        static size_t offset (void * o ) { return (size_t)(B*)(C*)o - (size_t)(C*)o; } 
        static OffsetFunction get() { return  & baseOffset::offset; }
      };


    /** 
     * @struct TypeDistiller TypeBuilder.h MLANG/Reflection/TypeBuilder.h
     * @author Pere Mato
     * @date 29/07/2004
     * @ingroup Ref
     */
    template<typename T> struct TypeDistiller {
      static Type get() { 
        //MLANG_String name = Tools::demangle(typeid(T));
        //Type t = Type::byName(name);
        Type t = Type::byTypeInfo(typeid(T));
        if ( ! t.id() ) t = Type::byName(Tools::demangle(typeid(T)));
        if ( t.id() ) return t;
        else {
          new TypeName(Tools::demangle(typeid(T)).c_str(),0);
          return Type::byName(Tools::demangle(typeid(T)));
        }
      }
    };


    template<typename T> struct TypeDistiller<T *> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T*));
        if ( t ) return t;
        else return (new Pointer(TypeDistiller<T>::get(),typeid(T *)))->type();
      }
    };


    template<typename T, size_t N > struct TypeDistiller<T[N]> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T*));
        if ( t ) return t;
        else return (new Array(TypeDistiller<T>::get(),N,typeid(NullType)))->type();
      }
    };


    template<typename T> struct TypeDistiller<const T> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, CONST );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),CONST);
      }
    };


    template<typename T> struct TypeDistiller<volatile T> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, VOLATILE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),VOLATILE);
      }
    };


    template<typename T> struct TypeDistiller<const volatile T> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, CONST | VOLATILE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),CONST|VOLATILE);
      }
    };


    template<typename T> struct TypeDistiller<T &> {
      static Type get() {
        // We can not use typeid(T&) because gives the same as typeid(T)
        Type t  = 0;
        Type pt = Type::byTypeInfo(typeid(T));
        if ( pt ) t = Type::byName(pt.name()+"&");
        if ( t ) return Type( t, REFERENCE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),REFERENCE);
      }
    };


    template<typename T> struct TypeDistiller<const T &> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, CONST | REFERENCE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),CONST|REFERENCE);
      }
    };


    template<typename T> struct TypeDistiller<volatile T &> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, VOLATILE | REFERENCE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),VOLATILE|REFERENCE);
      }
    };


    template<typename T> struct TypeDistiller<const volatile T &> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(T));
        if ( t ) return Type( t, CONST | VOLATILE | REFERENCE );
        else return Type(new TypeName(TypeDistiller<T>::get().name().c_str(),0),CONST|VOLATILE|REFERENCE);
      }
    };


    /**
     * getType will return a pointer to a Type (create it if necessery) 
     * representating the type of the template parameter
     * @return pointer to Type
     */
    template < typename T > 
      Type getType() {
      return TypeDistiller<T>::get();
    }


    /** 
     * @struct FuntionDistiller TypeBuilder.h MLANG/Reflection/TypeBuilder.h
     * @author Pere Mato
     * @date 29/07/2004
     * @ingroup Ref
     */
    template< typename S > struct FunctionDistiller;

    template< typename R > 
      struct FunctionDistiller<R(void)> {
      static inline Type get() { 
        Type t = Type::byTypeInfo(typeid(R(void)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(), 
                                       std::vector<Type>(), 
                                       typeid(R(void))))->type(); 
      }
    };

    template < typename R, typename T0 > 
      struct FunctionDistiller<R(T0)> {
      static inline Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(), 
                                       makeVector( TypeDistiller<T0>::get() ), 
                                       typeid(R(T0))))->type(); 
      }
    };
    template < typename R, typename T0, typename T1 > 
      struct FunctionDistiller<R(T0,T1)> {
      static inline Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1)));
        if ( t ) return t;
        else return (new Function( TypeDistiller<R>::get(), 
                                   makeVector( TypeDistiller<T0>::get(), 
                                               TypeDistiller<T1>::get()),
                                   typeid(R(T0, T1))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2 >
      struct FunctionDistiller<R(T0, T1, T2)> {
      static inline Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get()), 
                                       typeid(R(T0, T1, T2))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3 >
      struct FunctionDistiller<R(T0, T1, T2, T3)> {
      static inline Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get()), 
                                       typeid(R(T0, T1, T2, T3))))->type(); 
      }
    };
    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4)> {
        static Type get() {
          Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4)));
          if ( t ) return t;
          else     return (new Function( TypeDistiller<R>::get(),
                                         makeVector( TypeDistiller<T0>::get(),
                                                     TypeDistiller<T1>::get(),
                                                     TypeDistiller<T2>::get(), 
                                                     TypeDistiller<T3>::get(), 
                                                     TypeDistiller<T4>::get()), 
                                         typeid(R(T0, T1, T2, T3, T4))))->type(); 
        }
      };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get()), 
                                       typeid(R(T0, T1, T2, T3, T4, T5))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get()), 
                                       typeid(R(T0, T1, T2, T3, T4, T5, T6))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8)> {
        static Type get() {
          Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8)));
          if ( t ) return t;
          else     return (new Function( TypeDistiller<R>::get(),
                                         makeVector( TypeDistiller<T0>::get(),
                                                     TypeDistiller<T1>::get(),
                                                     TypeDistiller<T2>::get(), 
                                                     TypeDistiller<T3>::get(), 
                                                     TypeDistiller<T4>::get(), 
                                                     TypeDistiller<T5>::get(), 
                                                     TypeDistiller<T6>::get(),
                                                     TypeDistiller<T7>::get(), 
                                                     TypeDistiller<T8>::get()), 
                                         typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8))))->type(); 
        }
      };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get(), 
                                                   TypeDistiller<T10>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10))))->type(); 
      }
    };
    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10, typename T11 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get(), 
                                                   TypeDistiller<T10>::get(), 
                                                   TypeDistiller<T11>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11))))->type(); 
      }
    };

    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10, typename T11,
      typename T12 >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12)> {
        static Type get() {
          Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12)));
          if ( t ) return t;
          else     return (new Function( TypeDistiller<R>::get(),
                                         makeVector( TypeDistiller<T0>::get(),
                                                     TypeDistiller<T1>::get(),
                                                     TypeDistiller<T2>::get(), 
                                                     TypeDistiller<T3>::get(), 
                                                     TypeDistiller<T4>::get(), 
                                                     TypeDistiller<T5>::get(), 
                                                     TypeDistiller<T6>::get(),
                                                     TypeDistiller<T7>::get(), 
                                                     TypeDistiller<T8>::get(), 
                                                     TypeDistiller<T9>::get(), 
                                                     TypeDistiller<T10>::get(), 
                                                     TypeDistiller<T11>::get(), 
                                                     TypeDistiller<T12>::get()), 
                                         typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12))))->type(); 
        }
      };
    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10, typename T11,
      typename T12, typename T13  >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get(), 
                                                   TypeDistiller<T10>::get(), 
                                                   TypeDistiller<T11>::get(), 
                                                   TypeDistiller<T12>::get(), 
                                                   TypeDistiller<T13>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13))))->type(); 
      }
    };
    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10, typename T11,
      typename T12, typename T13, typename T14  >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get(), 
                                                   TypeDistiller<T10>::get(), 
                                                   TypeDistiller<T11>::get(), 
                                                   TypeDistiller<T12>::get(), 
                                                   TypeDistiller<T13>::get(), 
                                                   TypeDistiller<T14>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14))))->type(); 
      }
    };
    template < typename R, typename T0, typename T1, typename T2, typename T3,
      typename T4, typename T5, typename T6, typename T7,
      typename T8, typename T9, typename T10, typename T11,
      typename T12, typename T13, typename T14, typename T15  >
      struct FunctionDistiller<R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15)> {
      static Type get() {
        Type t = Type::byTypeInfo(typeid(R(T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15)));
        if ( t ) return t;
        else     return (new Function( TypeDistiller<R>::get(),
                                       makeVector( TypeDistiller<T0>::get(),
                                                   TypeDistiller<T1>::get(),
                                                   TypeDistiller<T2>::get(), 
                                                   TypeDistiller<T3>::get(), 
                                                   TypeDistiller<T4>::get(), 
                                                   TypeDistiller<T5>::get(), 
                                                   TypeDistiller<T6>::get(),
                                                   TypeDistiller<T7>::get(), 
                                                   TypeDistiller<T8>::get(), 
                                                   TypeDistiller<T9>::get(), 
                                                   TypeDistiller<T10>::get(), 
                                                   TypeDistiller<T11>::get(), 
                                                   TypeDistiller<T12>::get(), 
                                                   TypeDistiller<T13>::get(), 
                                                   TypeDistiller<T14>::get(), 
                                                   TypeDistiller<T15>::get()), 
                                       typeid(R( T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15))))->type(); 
      }
    };
  
    /**
     * makeVector is a utility function to create and initialize a std::vector of
     * number of items
     * @param t1 vector element
     * @return output vector
     */
    template <typename T >
      inline std::vector<T> makeVector(T t0) { 
      std::vector<T> v; 
      v.push_back(t0);
      return v; 
    }
  
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1);
      return v;
    }
  
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2);
      return v;
    }

    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10, T t11 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10); v.push_back(t11);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10, T t11, T t12 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10); v.push_back(t11); v.push_back(t12);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10, T t11, T t12, T t13 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10); v.push_back(t11); v.push_back(t12); v.push_back(t13);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10, T t11, T t12, T t13, T t14 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10); v.push_back(t11); v.push_back(t12); v.push_back(t13); v.push_back(t14);
      return v;
    }
    template <typename T >
      inline std::vector<T> makeVector(T t0, T t1, T t2, T t3, T t4, T t5, T t6, T t7,
                                       T t8, T t9, T t10, T t11, T t12, T t13, T t14, T t15 ) {
      std::vector<T> v;
      v.push_back(t0); v.push_back(t1); v.push_back(t2); v.push_back(t3); v.push_back(t4);
      v.push_back(t5); v.push_back(t6); v.push_back(t7), v.push_back(t8); v.push_back(t9);
      v.push_back(t10); v.push_back(t11); v.push_back(t12); v.push_back(t13); v.push_back(t14);
      v.push_back(t15);
      return v;
    }

} // namespace MLANG_Reflection

#endif //SEAL_REFLECT_ TYPEBUILDER_H
