#ifndef __MPARSER_CHARSTREAMEXCEPTION_H__
#define __MPARSER_CHARSTREAMEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/Exception.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharStreamException.java#1 $
 */

/**
 * Anything that goes wrong while generating a stream of characters
 */
namespace MParser
{
class CharStreamException : public MParser_Exception
{
public:
   typedef MParser_Exception super;
public:
   /**
    * CharStreamException constructor comment.
    * @param s java.lang.String
    */
   CharStreamException(const MLANG_String& s);
   virtual ~CharStreamException();
};
}

typedef MParser::CharStreamException MParser_CharStreamException;

#endif /* __MPARSER_CHARSTREAMEXCEPTION_H__ */
