#include "MParser/FileLineFormatter.h"
#include "MParser/DefaultFileLineFormatter.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/FileLineFormatter.java#1 $
 */

MIO_FileLineFormatter_ptr
MIO_FileLineFormatter::formatter_ = new MParser_DefaultFileLineFormatter();

MIO_FileLineFormatter::MIO_FileLineFormatter()

{
}

MIO_FileLineFormatter_ptr MIO_FileLineFormatter::getFormatter()

{
   return formatter_;
}

void MIO_FileLineFormatter::setFormatter(MIO_FileLineFormatter_ptr f)

{
   formatter_ = f;
}

MIO_FileLineFormatter::~MIO_FileLineFormatter()

{
}
