#include "MParser/ParserSharedInputState.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/ParserSharedInputState.java#1 $
 */

/** This object contains the data associated with an
 *  input stream of tokens.  Multiple parsers
 *  share a single ParserSharedInputState to parse
 *  the same stream of tokens.
 */

/** Are we guessing (guessing>0)? */
MParser_ParserSharedInputState::MParser_ParserSharedInputState()
  : guessing_(0)

{
}

void MParser_ParserSharedInputState::reset()

{
   guessing_ = 0;
   filename_.clear();
   input_->reset();
}

MParser_ParserSharedInputState::~MParser_ParserSharedInputState()

{
}
