#include "MParser/SemanticException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/SemanticException.java#1 $
 */

MParser_SemanticException::MParser_SemanticException (
   const MLANG_String& s,
   const MLANG_String& fileName,
   int line,
   int column
) : super(s.c_str(), fileName.c_str(), line, column)

{
}

MParser_SemanticException::~MParser_SemanticException ()

{
}
