#include "MParser/TokenStreamIOException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamIOException.java#1 $
 */

/**
 * Wraps an IOException in a TokenStreamException
 */
/**
 * TokenStreamIOException constructor comment.
 * @param s java.lang.String
 */
MParser_TokenStreamIOException::MParser_TokenStreamIOException (
   MIO_IOException& ex
) : super(io.getMessage().c_str()),
    io(ex)
   
{
}

MParser_TokenStreamIOException::~MParser_TokenStreamIOException ()

{
}
