#ifndef __MPARSER_TOKENSTREAMIOEXCEPTION_H__
#define __MPARSER_TOKENSTREAMIOEXCEPTION_H__
#include "MIO/IOException.h"
#include "MParser/TokenStreamException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamIOException.java#1 $
 */

/**
 * Wraps an IOException in a TokenStreamException
 */
class MParser_TokenStreamIOException : public MParser_TokenStreamException

{
public:
   typedef MParser_TokenStreamException super;
   
public:
   MIO_IOException& io;

    /**
     * TokenStreamIOException constructor comment.
     * @param s java.lang.String
     */
public:
    MParser_TokenStreamIOException(MIO_IOException& io);
    virtual ~MParser_TokenStreamIOException();
};

#endif /* __MPARSER_TOKENSTREAMIOEXCEPTION_H__ */
