#ifndef __MPARSER_TREEPARSERSHAREDINPUTSTATE_H__
#define __MPARSER_TREEPARSERSHAREDINPUTSTATE_H__

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TreeParserSharedInputState.java#1 $
 */

/** This object contains the data associated with an
 *  input AST.  Multiple parsers
 *  share a single TreeParserSharedInputState to parse
 *  the same tree or to have the parser walk multiple
 *  trees.
 */
class MParser_TreeParserSharedInputState

{
public:
   /** Are we guessing (guessing>0)? */
   int guessing_;
public:
   MParser_TreeParserSharedInputState();
   virtual ~MParser_TreeParserSharedInputState();
public:
   int guessing() const
   { return guessing_; }
};

#endif /* __MPARSER_TREEPARSERSHAREDINPUTSTATE_H__ */
