#include "mbase/byutils.h"
#include "mbase/blob.h"

void tblobload (
   tblob_t* tblob,
   const unsigned char* from
)

{
   tblob->tb_fd = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_coloff = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_tblspace = ldlong(from);
   from += sizeof(integer);
   tblob->tb_start = ldlong(from);
   from += sizeof(integer);
   tblob->tb_end = ldlong(from);
   from += sizeof(integer);
   tblob->tb_size = ldlong(from);
   from += sizeof(integer);
   tblob->tb_addr = ldlong(from);
   from += sizeof(integer);
   tblob->tb_family = ldlong(from);
   from += sizeof(integer);
   tblob->tb_volume = ldlong(from);
   from += sizeof(integer);
   tblob->tb_medium = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_bstamp = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_sockid = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_flags = ldshort(from);
   from += sizeof(smallint);
   tblob->tb_reserved1 = ldlong(from);
   from += sizeof(integer);
   tblob->tb_reserved2 = ldlong(from);
   from += sizeof(integer);
   tblob->tb_reserved3 = ldlong(from);
   from += sizeof(integer);
   tblob->tb_reserved4 = ldlong(from);
   from += sizeof(integer);
}

void tblobstore (
   const tblob_t* tblob,
   unsigned char* to
)

{
   byfill(to, sizeof(tblob_t), 0);
   stshort(tblob->tb_fd, to);
   to += sizeof(smallint);
   stshort(tblob->tb_coloff, to);
   to += sizeof(smallint);
   stlong(tblob->tb_tblspace, to);
   to += sizeof(integer);
   stlong(tblob->tb_start, to);
   to += sizeof(integer);
   stlong(tblob->tb_end, to);
   to += sizeof(integer);
   stlong(tblob->tb_size, to);
   to += sizeof(integer);
   stlong(tblob->tb_addr, to);
   to += sizeof(integer);
   stlong(tblob->tb_family, to);
   to += sizeof(integer);
   stlong(tblob->tb_volume, to);
   to += sizeof(integer);
   stshort(tblob->tb_medium, to);
   to += sizeof(smallint);
   stshort(tblob->tb_bstamp, to);
   to += sizeof(smallint);
   stshort(tblob->tb_sockid, to);
   to += sizeof(smallint);
   stshort(tblob->tb_flags, to);
   to += sizeof(smallint);
   stlong(tblob->tb_reserved1, to);
   to += sizeof(integer);
   stlong(tblob->tb_reserved2, to);
   to += sizeof(integer);
   stlong(tblob->tb_reserved3, to);
   to += sizeof(integer);
   stlong(tblob->tb_reserved4, to);
   to += sizeof(integer);
}
