#ifndef __MBASE_PROCESS_H__
#define __MBASE_PROCESS_H__

#include "mbase/config.h"

#ifdef WIN32

#include <process.h>
#if !defined(__MINGW32__)
typedef long pid_t;
#endif /* __MINGW32__ */

#ifndef PIPE_BUF
#define PIPE_BUF 5120
#endif /* PIPE_BUF */

EXTERN_C MExport int setpgrp();

EXTERN_C MExport pid_t fork();

EXTERN_C MExport int kill (
   pid_t pid,
   int signum
);

EXTERN_C MExport int pipe (
   int fd[]
);

EXTERN_C MExport int wait (
   int *status
);

#endif /* WIN32 */

#endif /* __MBASE_PROCESS_H__ */
