#ifndef __MBASE_PWD_H__
#define __MBASE_PWD_H__
#include "mbase/config.h"

#ifdef WIN32

typedef int muid_t;

EXTERN_C
struct passwd
{
    char *pw_name;
    char *pw_passwd;
    muid_t pw_uid;
};

EXTERN_C MExport
muid_t getuid();

EXTERN_C MExport
struct passwd *getpwent();

EXTERN_C MExport
struct passwd *getpwuid(muid_t uid);

EXTERN_C MExport
struct passwd *getpwnam(const char* name);

EXTERN_C MExport
void setpwent();

EXTERN_C MExport
void endpwent();

#else /* WIN32 */
#include <pwd.h>
#endif /* WIN32 */

#endif /* __MBASE_PWD_H__ */
