#include "mbase/smallint.h"

int mrstoi (
   const char* buf,
   short *s
)

{
   register int n; /* esi */
   register const char* p; /* edi */
   int sign = 0;

   for (p = buf; *p==' '; p++);
   if (*p=='\0')
    { 
      *s = (short)0x8000;
      return 0;
    }
   sign = *p=='-';
   if (*p=='-' || *p=='+')
    p++;

   if (*p<'0' || *p>'9')
    return 0xfffffb43;

   for (n = 0; *p>='0' && *p<='9'; p++)
    {
      if (n<0xccc || (n==0xccc && *p<='7'))
	n = 10 * n + (*p - '0');
      else
        return 0xfffffb42;
    }
   if (*p!='\0' && *p!=' ' && *p!='\n')
    return 0xfffffb43;
   if (sign)
    n = - n;
   *s = n;
   return 0;
}
