#ifndef __MPARSER_ANTLRTOKENTYPES_H__
#define __MPARSER_ANTLRTOKENTYPES_H__

#undef EOF

class ANTLRTokenTypes
{
public:
   enum
   {
     EOF = 1,
     NULL_TREE_LOOKAHEAD = 3,
     LITERAL_tokens = 4,
     LITERAL_header = 5,
     STRING_LITERAL = 6,
     ACTION = 7,
     DOC_COMMENT = 8,
     LITERAL_lexclass = 9,
     LITERAL_class = 10,
     LITERAL_extends = 11,
     LITERAL_Lexer = 12,
     LITERAL_TreeParser = 13,
     OPTIONS = 14,
     ASSIGN = 15,
     SEMI = 16,
     RCURLY = 17,
     LITERAL_charVocabulary = 18,
     CHAR_LITERAL = 19,
     INT = 20,
     OR = 21,
     RANGE = 22,
     TOKENS = 23,
     TOKEN_REF = 24,
     OPEN_ELEMENT_OPTION = 25,
     CLOSE_ELEMENT_OPTION = 26,
     LPAREN = 27,
     RPAREN = 28,
     LITERAL_Parser = 29,
     LITERAL_protected = 30,
     LITERAL_public = 31,
     LITERAL_private = 32,
     BANG = 33,
     ARG_ACTION = 34,
     LITERAL_returns = 35,
     COLON = 36,
     LITERAL_throws = 37,
     COMMA = 38,
     LITERAL_exception = 39,
     LITERAL_catch = 40,
     RULE_REF = 41,
     NOT_OP = 42,
     SEMPRED = 43,
     TREE_BEGIN = 44,
     QUESTION = 45,
     STAR = 46,
     PLUS = 47,
     IMPLIES = 48,
     CARET = 49,
     WILDCARD = 50,
     LITERAL_options = 51,
     WS = 52,
     COMMENT = 53,
     SL_COMMENT = 54,
     ML_COMMENT = 55,
     ESC = 56,
     DIGIT = 57,
     XDIGIT = 58,
     NESTED_ARG_ACTION = 59,
     NESTED_ACTION = 60,
     WS_LOOP = 61,
     INTERNAL_RULE_REF = 62,
     WS_OPT = 63
   };
};

#endif /* __MPARSER_ANTLRTOKENTYPES_H__ */
