#include "MGrammar/Grammar.h"
#include "MGrammar/BlockWithImpliedExitPath.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/BlockWithImpliedExitPath.java#1 $
 */

MGrammar_BlockWithImpliedExitPath::MGrammar_BlockWithImpliedExitPath (
   MGrammar_Grammar_ptr g
) : MGrammar_AlternativeBlock(g),
    exitCache_(g->maxk_ + 1)

{
   for (int j=0; j<grammar_->maxk_ + 1; j++)
       exitCache_[j].set_null();
}

MGrammar_BlockWithImpliedExitPath::MGrammar_BlockWithImpliedExitPath (
   MGrammar_Grammar_ptr g,
   const MParser_Token_var& start
) : MGrammar_AlternativeBlock(g, start, false),
    exitCache_(g->maxk_ + 1)

{
   for (int j=0; j<grammar_->maxk_ + 1; j++)
       exitCache_[j].set_null();
}

MGrammar_BlockWithImpliedExitPath::~MGrammar_BlockWithImpliedExitPath ()

{
}
