#ifndef __MGRAMMAR_ACTIONLEXERTOKENTYPES_H__
#define __MGRAMMAR_ACTIONLEXERTOKENTYPES_H__
#undef EOF

class MGrammar_CppActionLexerTokenTypes

{
public:
    MGrammar_CppActionLexerTokenTypes() {}
    virtual ~MGrammar_CppActionLexerTokenTypes() {}
public:
    enum {
    EOF = 1,
    NULL_TREE_LOOKAHEAD = 3,
    ACTION = 4,
    STUFF = 5,
    AST_ITEM = 6,
    TEXT_ITEM = 7,
    TREE = 8,
    TREE_ELEMENT = 9,
    AST_CONSTRUCTOR = 10,
    AST_CTOR_ELEMENT = 11,
    ID_ELEMENT = 12,
    TEXT_ARG = 13,
    TEXT_ARG_ELEMENT = 14,
    TEXT_ARG_ID_ELEMENT = 15,
    ARG = 16,
    ID = 17,
    VAR_ASSIGN = 18,
    COMMENT = 19,
    SL_COMMENT = 20,
    ML_COMMENT = 21,
    CHAR = 22,
    STRING = 23,
    ESC = 24,
    DIGIT = 25,
    INT = 26,
    INT_OR_FLOAT = 27,
    WS = 28
   };
private:
    MGrammar_CppActionLexerTokenTypes(const MGrammar_CppActionLexerTokenTypes&);
    MGrammar_CppActionLexerTokenTypes& operator=(const MGrammar_CppActionLexerTokenTypes&);
};

#endif /* __MGRAMMAR_ACTIONLEXERTOKENTYPES_H__ */
