#ifndef __MGRAMMAR_LLKGRAMMARANALYZER_H__
#define __MGRAMMAR_LLKGRAMMARANALYZER_H__
#include "MLANG/String.h"
#include "MGrammar/AlternativeBlock.h"
#include "MGrammar/GrammarAnalyzer.h"

class MGrammar_LLkGrammarAnalyzer;
typedef class MGrammar_LLkGrammarAnalyzer *MGrammar_LLkGrammarAnalyzer_ptr;
typedef MLANG_SmartPtr<MGrammar_LLkGrammarAnalyzer> MGrammar_LLkGrammarAnalyzer_var;
class MGrammar_AlternativeBlock;
typedef class MGrammar_AlternativeBlock *MGrammar_AlternativeBlock_ptr;
class MGrammar_OneOrMoreBlock;
typedef class MGrammar_OneOrMoreBlock *MGrammar_OneOrMoreBlock_ptr;
class MGrammar_ZeroOrMoreBlock;
typedef class MGrammar_ZeroOrMoreBlock *MGrammar_ZeroOrMoreBlock_ptr;
class MGrammar_RuleEndElement;
typedef class MGrammar_RuleEndElement *MGrammar_RuleEndElement_ptr;
class MGrammar_ActionElement;
typedef class MGrammar_ActionElement *MGrammar_ActionElement_ptr;
class MGrammar_AlternativeBlock;
typedef class MGrammar_AlternativeBlock *MGrammar_AlternativeBlock_ptr;
class MGrammar_BlockEndElement;
typedef class MGrammar_BlockEndElement *MGrammar_BlockEndElement_ptr;
class MGrammar_CharLiteralElement;
typedef class MGrammar_CharLiteralElement *MGrammar_CharLiteralElement_ptr;
class MGrammar_CharRangeElement;
typedef class MGrammar_CharRangeElement *MGrammar_CharRangeElement_ptr;
class MGrammar_GrammarAtom;
typedef class MGrammar_GrammarAtom *MGrammar_GrammarAtom_ptr;
class MGrammar_OneOrMoreBlock;
typedef class MGrammar_OneOrMoreBlock *MGrammar_OneOrMoreBlock_ptr;
class MGrammar_RuleBlock;
typedef class MGrammar_RuleBlock *MGrammar_RuleBlock_ptr;
class MGrammar_RuleEndElement;
typedef class MGrammar_RuleEndElement *MGrammar_RuleEndElement_ptr;
class MGrammar_RuleRefElement;
typedef class MGrammar_RuleRefElement *MGrammar_RuleRefElement_ptr;
class MGrammar_StringLiteralElement;
typedef class MGrammar_StringLiteralElement *MGrammar_StringLiteralElement_ptr;
class MGrammar_SynPredBlock;
typedef class MGrammar_SynPredBlock *MGrammar_SynPredBlock_ptr;
class MGrammar_TokenRangeElement;
typedef class MGrammar_TokenRangeElement *MGrammar_TokenRangeElement_ptr;
class MGrammar_TreeElement;
typedef class MGrammar_TreeElement *MGrammar_TreeElement_ptr;
class MGrammar_WildcardElement;
typedef class MGrammar_WildcardElement *MGrammar_WildcardElement_ptr;
class MGrammar_ZeroOrMoreBlock;
typedef class MGrammar_ZeroOrMoreBlock *MGrammar_ZeroOrMoreBlock_ptr;
class MGrammar_AlternativeBlock;
typedef class MGrammar_AlternativeBlock *MGrammar_AlternativeBlock_ptr;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/LLkGrammarAnalyzer.java#1 $
 */

class MGrammar_LLkGrammarAnalyzer : public MGrammar_GrammarAnalyzer

{
public:
    MGrammar_LLkGrammarAnalyzer();
    virtual ~MGrammar_LLkGrammarAnalyzer();

public:

   static bool is_nil (MGrammar_LLkGrammarAnalyzer_ptr analyzer)
   { return analyzer == 0; }

   static MGrammar_LLkGrammarAnalyzer_ptr _nil()
   { return 0; }

   static MGrammar_LLkGrammarAnalyzer_ptr _duplicate(MGrammar_LLkGrammarAnalyzer_ptr analyzer)
   { return MLANG_acquire(analyzer); }

public:

    virtual bool deterministic(MGrammar_AlternativeBlock_ptr blk) = 0;

    virtual bool deterministic(MGrammar_OneOrMoreBlock_ptr blk) = 0;

    virtual bool deterministic(MGrammar_ZeroOrMoreBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead FOLLOW(int k, MGrammar_RuleEndElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_ActionElement_ptr action) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_AlternativeBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_BlockEndElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_CharLiteralElement_ptr atom) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_CharRangeElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_GrammarAtom_ptr atom) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_OneOrMoreBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_RuleBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_RuleEndElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_RuleRefElement_ptr rr) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_StringLiteralElement_ptr atom) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_SynPredBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_TokenRangeElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_TreeElement_ptr end) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_WildcardElement_ptr wc) = 0;

    virtual MGrammar_Lookahead look(int k, MGrammar_ZeroOrMoreBlock_ptr blk) = 0;

    virtual MGrammar_Lookahead look(int k, const MLANG_String& rule) = 0;

    virtual void setGrammar(MGrammar_Grammar_ptr g) = 0;

    virtual bool subruleCanBeInverted(MGrammar_AlternativeBlock_ptr blk, bool forLexer) = 0;
};

#endif /* __MGRAMMAR_LLKGRAMMARANALYZER_H__ */
