#include "MParser/Token.h"
#include "MGrammar/TokenSymbol.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenSymbol.java#1 $
 */

MGrammar_TokenSymbol::MGrammar_TokenSymbol(const MLANG_String& r)
  : MGrammar_GrammarSymbol(r),
    ttype_(MParser_Token::INVALID_TYPE)

{
}

MLANG_String MGrammar_TokenSymbol::getASTNodeType() const

{
   return ASTNodeType_;
}

void MGrammar_TokenSymbol::setASTNodeType(const MLANG_String& type)

{
   ASTNodeType_ = type;
}

MLANG_String MGrammar_TokenSymbol::getParaphrase() const

{
   return paraphrase_;
}

int MGrammar_TokenSymbol::getTokenType() const

{
   return ttype_;
}

void MGrammar_TokenSymbol::setParaphrase(const MLANG_String& p)

{
   paraphrase_ = p;
}

void MGrammar_TokenSymbol::setTokenType(int t) 

{
   ttype_ = t;
}

MGrammar_TokenSymbol::~MGrammar_TokenSymbol()

{
}
