#include "MIO/FileOutputStream.h"
#include "MIO/FileWriter.h"

MIO_FileWriter::MIO_FileWriter (
   const MIO_File_var& fileName,
   bool append
 ) : MIO_OutputStreamWriter (new MIO_FileOutputStream(fileName, append))

{
}

MIO_FileWriter::MIO_FileWriter (
   const MLANG_String& fileName,
   bool append
 ) : MIO_OutputStreamWriter (new MIO_FileOutputStream(fileName, append))

{
}

MIO_FileWriter::~MIO_FileWriter()

{
}
