#include "MIO/FilterOutputStream.h"

MIO_FilterOutputStream::MIO_FilterOutputStream (
   const MIO_OutputStream_var& output
) : output_(output)

{
}

void MIO_FilterOutputStream::close()

{
   output_->close();
}

void MIO_FilterOutputStream::flush()

{
   output_->flush();
}

void MIO_FilterOutputStream::write (const char* buf, ssize_t len)

{
   for (ssize_t i=0; i<len; i++)
     this->write (buf[i]);
}

void MIO_FilterOutputStream::write (char c)

{
   output_->write (&c, 1);
}

MIO_FilterOutputStream::~MIO_FilterOutputStream()

{
}
