/* -*- C++ -*- */
//Refcountable.inl,v 4.1 2001/12/10 21:44:43 bala Exp
template <class LOCK>
ACE_INLINE
MLANG::Refcountable<LOCK>::Refcountable (size_t refcount)
  : refcount_ (refcount)
{
}

template <class LOCK>
ACE_INLINE
MLANG::Refcountable<LOCK>::~Refcountable (void)
{
}

template <class LOCK>
ACE_INLINE size_t
MLANG::Refcountable<LOCK>::increment (void)
{
  return ++this->refcount_;
}

template <class LOCK>
ACE_INLINE size_t
MLANG::Refcountable<LOCK>::decrement (void)
{
  size_t newcount = --this->refcount_;
  if (newcount == 0)
   {
     delete this;
   }
  return newcount;
}

template <class LOCK>
ACE_INLINE size_t
MLANG::Refcountable<LOCK>::refcount (void)
{
  return this->refcount_;
}
