//$Id: Base.cpp,v 1.7 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/Base.h"
#include "MLANG/Reflection/Class.h"

//-------------------------------------------------------------------------------
MLANG_Reflection::Base::Base( const Type &    baseType,
                          OffsetFunction  offsetFP,
			                    unsigned int    modifiers )
//-------------------------------------------------------------------------------
  : m_offsetFP( offsetFP ),
    m_modifiers( modifiers ),
    m_baseType(Type()) {

  m_baseType = baseType;
}


//-------------------------------------------------------------------------------
MLANG_String MLANG_Reflection::Base::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  MLANG_String s = "";
  if ( isPublic())    { s += "public "; }
  if ( isProtected()) { s += "protected "; }
  if ( isPrivate())   { s += "private "; }
  if ( isVirtual())   { s += "virtual "; }
  s += m_baseType.fullName(typedefexp);
  return s;
}
