//$Id: InstantiatedTemplateClass.cpp,v 1.4 2004/11/01 10:12:02 roiser Exp $

#include "Reflection/InstantiatedTemplateClass.h"
#include "Reflection/InstantiatedTemplate.h"


//-------------------------------------------------------------------------------
MLANG_Reflection::InstantiatedTemplateClass::
InstantiatedTemplateClass( const char * type, 
                           size_t size, 
                           const std::type_info & typeInfo, 
                           const TemplateFamily * templateFamily,
                           std::vector < TemplateArgument > & templateArguments )
//-------------------------------------------------------------------------------
  : Class( type, size, typeInfo, 0, INSTANTIATEDTEMPLATECLASS ),
    InstantiatedTemplate( templateFamily, 
                          INSTANTIATEDTEMPLATECLASS, 
                          templateArguments ) {}


//-------------------------------------------------------------------------------
MLANG_String 
MLANG_Reflection::InstantiatedTemplateClass::fullName(bool typedefexp) const {
//-------------------------------------------------------------------------------
     return "template " + InstantiatedTemplate::fullName(typedefexp) + " " +
        Class::fullName();
}
