//$Id: InstantiatedTemplateFunction.cpp,v 1.6 2004/11/30 22:57:58 roiser Exp $

#include "MLANG/Reflection/InstantiatedTemplateFunction.h"

std::vector<MLANG_Reflection::Type> tv = std::vector<MLANG_Reflection::Type>();
//-------------------------------------------------------------------------------
MLANG_Reflection::InstantiatedTemplateFunction::
InstantiatedTemplateFunction( const char * /*type*/,
                              size_t /*size*/,
                              const std::type_info & typeInfo,
                              const char * /*returnType*/,
                              const char * /*parameterTypes*/,
                              const TemplateFamily & templateFamily,
                              const std::vector < TemplateArgument > templateArguments )
//-------------------------------------------------------------------------------
  : Function( Type(), 
              tv, 
              typeInfo, 
              INSTANTIATEDTEMPLATEFUNCTION ),
    InstantiatedTemplate( & templateFamily, 
                          INSTANTIATEDTEMPLATEFUNCTION, 
                          templateArguments ) {}


//-------------------------------------------------------------------------------
MLANG_String 
MLANG_Reflection::InstantiatedTemplateFunction::fullName( bool typedefexp ) const {
//-------------------------------------------------------------------------------
  return "template " + InstantiatedTemplate::fullName( typedefexp ) + " " +
    Function::fullName( typedefexp );
}

