/* -*- C++ -*- */

ACE_INLINE
int MLANG::compare (
   const String& a,
   const String& b
)
{ return strcmp (a.buf_, b.buf_); }

ACE_INLINE
size_t MLANG::String::length() const
{ return len_; }

ACE_INLINE
int MLANG::String::operator< (
   const String& b
) const
{ return compare (*this, b) < 0; }

ACE_INLINE
int MLANG::String::operator<= (
   const String& b
) const
{ return compare (*this, b) <= 0; }

ACE_INLINE
int MLANG::String::operator== (
   const String& b
) const
{ return compare (*this, b) == 0; }

ACE_INLINE
int MLANG::String::operator!= (
   const String& b
) const
{ return compare (*this, b) != 0; }
