#include "MParser/CharStreamException.h"

using namespace MParser;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CharStreamException.java#1 $
 */

/**
 * Anything that goes wrong while generating a stream of characters
 */
/**
 * CharStreamException constructor comment.
 * @param s java.lang.String
 */
CharStreamException::CharStreamException (
   const MLANG_String& s
)
  : super(s.c_str())

{
}

CharStreamException::~CharStreamException ()

{
}
