#include "MParser/CommonToken.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/CommonToken.java#1 $
 */

DEFINE_CLASS_INFO (MParser_CommonToken)

MParser_CommonToken::MParser_CommonToken(int t, const MLANG_String& txt)
   : MParser_Token (t),
     text_(txt)

{
}

MParser_CommonToken::MParser_CommonToken(const MLANG_String& s)
  : text_(s)

{
}

MLANG_String MParser_CommonToken::toString() const

{
   return "[\"" + 
          getText() + 
          "\",<" + 
         MLANG_String::valueOf(type_) + 
          ">,line=" + 
         MLANG_String::valueOf(line_) + 
          ",col=" + 
         MLANG_String::valueOf(col_) + 
          "]";
}

MParser_CommonToken::~MParser_CommonToken()

{
}
