#ifndef __MPARSER_DEFAULTFILELINEFORMATTER_H__
#define __MPARSER_DEFAULTFILELINEFORMATTER_H__
#include "MLANG/String.h"
#include "MParser/FileLineFormatter.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/DefaultFileLineFormatter.java#1 $
 */

class MParser_DefaultFileLineFormatter : public MIO_FileLineFormatter

{
public:
   MParser_DefaultFileLineFormatter();
   virtual ~MParser_DefaultFileLineFormatter();

public:

    MLANG_String getFormatString (const MLANG_String& fileName, int line, int column);
};

#endif /* __MPARSER_DEFAULTFILELINEFORMATTER_H__ */
