#ifndef __MPARSER_NUMBERFORMATEXCEPTION_H__
#define __MPARSER_NUMBERFORMATEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/Exception.h"

class MParser_NumberFormatException;
typedef class MParser_NumberFormatException *MParser_NumberFormatException_ptr;
typedef class MParser_NumberFormatException *MParser_NumberFormatException_var;

class MParser_NumberFormatException : public MParser_Exception
{
public:
    MParser_NumberFormatException(const char *s = "");
    virtual ~MParser_NumberFormatException(); 
public:
    virtual MLANG_String toString() const
    { return message_; }
    virtual MLANG_String getMessage() const
    { return toString(); }
};

#endif /* __MPARSER_NUMBERFORMATEXCEPTION_H__ */
