#ifndef __MPARSER_SEMANTICEXCEPTION_H__
#define __MPARSER_SEMANTICEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/RecognitionException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/SemanticException.java#1 $
 */

class MParser_SemanticException : public MParser_RecognitionException

{
public:
   typedef MParser_RecognitionException super;
public:

    MParser_SemanticException (
       const MLANG_String& s,
       const MLANG_String& fileName = "",
       int line = -1,
       int column = -1
     );

    virtual ~MParser_SemanticException ();
};

#endif /* __MPARSER_SEMANTICEXCEPTION_H__ */
