#ifndef __MPARSER_TOKENFACTORY_H__
#define __MPARSER_TOKENFACTORY_H__
#include "ace/Synch.h"
#include "MLANG/Object.h"
#include "MLANG/SmartPtr.h"
#include "MParser/Token.h"

class MParser_TokenFactory;
typedef class MParser_TokenFactory *MParser_TokenFactory_ptr;

class MParser_TokenFactory : public MLANG_Object
{
protected:
   MParser_TokenFactory();
public:
   virtual ~MParser_TokenFactory();
public:
   virtual MParser_Token_ptr alloc() = 0;   
};

typedef MLANG_SmartPtr<MParser_TokenFactory> MParser_TokenFactory_var;

#endif /* __MPARSER_TOKENFACTORY_H__ */
