#include "MParser/TokenStreamException.h"

using namespace MParser;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamException.java#1 $
 */

/**
 * Anything that goes wrong while generating a stream of tokens.
 */
TokenStreamException::TokenStreamException() 

{
}

TokenStreamException::TokenStreamException (
   const MLANG_String& s
) : super(s.c_str())

{
}

TokenStreamException::~TokenStreamException() 

{
}
