#ifndef __MPARSER_TOKENSTREAMEXCEPTION_H__
#define __MPARSER_TOKENSTREAMEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/Exception.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamException.java#1 $
 */

namespace MParser
{
/**
 * Anything that goes wrong while generating a stream of tokens.
 */
class TokenStreamException : public MParser_Exception
{
public:
   typedef MParser_Exception super;
public:
    TokenStreamException();

    TokenStreamException(const MLANG_String& s);

    virtual ~TokenStreamException();
};
}

typedef MParser::TokenStreamException MParser_TokenStreamException;

#endif /* __MPARSER_TOKENSTREAMEXCEPTION_H__ */
