#include "MParser/TokenStreamRecognitionException.h"

using namespace MParser;

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamRecognitionException.java#1 $
 */

TokenStreamRecognitionException::TokenStreamRecognitionException(MParser_RecognitionException& re)
 : super(re.getMessage().c_str()),
   recog_(re)
{
}

MLANG_String TokenStreamRecognitionException::toString() const

{
   return recog_.toString();
}

TokenStreamRecognitionException::~TokenStreamRecognitionException()

{
}
