#ifndef __MPARSER_TOKENSTREAMRECOGNTIONEXCEPTION_H__
#define __MPARSER_TOKENSTREAMRECOGNTIONEXCEPTION_H__
#include "MLANG/String.h"
#include "MParser/TokenStreamException.h"
#include "MParser/RecognitionException.h"

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/license.html
 *
 * $Id: //depot/code/org.antlr/release/antlr-2.7.4/antlr/TokenStreamRecognitionException.java#1 $
 */

namespace MParser
{
/**
 * Wraps a RecognitionException in a TokenStreamException so you
 * can pass it along.
 */
class TokenStreamRecognitionException : public MParser_TokenStreamException

{
public:
    typedef MParser_TokenStreamException super;
public:
    RecognitionException& recog_;

    TokenStreamRecognitionException(MParser_RecognitionException& re);
    virtual ~TokenStreamRecognitionException();
public:
    MLANG_String toString() const;
};
}

typedef MParser::TokenStreamRecognitionException MParser_TokenStreamRecognitionException;

#endif /* __MPARSER_TOKENSTREAMRECOGNTIONEXCEPTION_H__ */
