#ifndef __MBASE_FLOAT_H__
#define __MBASE_FLOAT_H__
#include "mbase/config.h"

EXTERN_C MExport
double mlddbl (
   const unsigned char* from
);

EXTERN_C MExport
double mldfloat (
   const unsigned char* from
);

EXTERN_C MExport
double mlddblnull (
   const unsigned char* from,
   short* ind
);

EXTERN_C MExport
double mldfltnull (
   const unsigned char* from,
   short* ind
);

EXTERN_C MExport
void mstdblnull (
   double dbl,
   unsigned char* to,
   short ind
);

EXTERN_C MExport
void mstfltnull (
   double dbl,
   unsigned char* to,
   short ind
);

EXTERN_C MExport
void mstdbl (
   double dbl,
   unsigned char* to
);

EXTERN_C MExport
void mstfloat (
   double dbl,
   unsigned char* to
);

#ifndef NO_INFORMIX_MAP
#define lddbl mlddbl
#define ldfloat mldfloat
#define lddblnull mlddblnull
#define ldfltnull mldfltnull
#define stdblnull mstdblnull
#define stfltnull mstfltnull
#define stdbl mstdbl
#define stfloat mstfloat
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_FLOAT_H__ */
