#if !defined(__MBASE_INTEGER_H__)
#define __MBASE_INTEGER_H__
#include "mbase/config.h"

typedef long integer;
#ifndef NO_INFORMIX_MAP
typedef long mlong;
typedef unsigned long mulong;
#endif /* NO_INFORMIX_MAP */
typedef unsigned long uinteger;

EXTERN_C MExport
int mrstol (
   const char* buf,
   integer *l
);

EXTERN_C MExport
int mrstol (
   const char* buf,
   integer* l
);

EXTERN_C MExport
integer mldlong (
   const unsigned char from[]
);

EXTERN_C MExport
void mstlong (
   integer l,
   unsigned char to[]
);

#define LONGSIZE sizeof(integer)

#ifndef NO_INFORMIX_MAP
#define rstol mrstol
#define ldlong mldlong
#define stlong mstlong
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_INTEGER_H__ */
