#ifndef __MBASE_MOBJECT_H__
#define __MBASE_MOBJECT_H__
#include "mbase/config.h"

EXTERN_C
struct mobject_s;
typedef struct mobject_s* mobject;
typedef void (*mfree)(mobject);

EXTERN_C
struct mvtable_s
{
   mfree free;   
};
typedef struct mvtable_s* mvtable;


struct mobject_s
{
   mvtable vtable;
};

EXTERN_C MExport 
mobject comalloc (
   size_t size,
   mvtable vtable
);

EXTERN_C MExport 
void cofree (
  mobject o
);

#define conew(c) (c) comalloc(sizeof(struct c##_##s), (mvtable)&c##_##vtable)
#define codelete(o) (cofree((mobject) (o)))

#endif /* __MBASE_MOBJECT_H__ */
