#ifndef __MBASE_RDATE_H__
#define __MBASE_RDATE_H__
#include "mbase/config.h"
#include "mbase/sqltypes.h"

#define MAXDATEFMTLEN	10

#if !defined(ACE_HAS_DATE_STRUCT)
#define ACE_HAS_DATE_STRUCT
/* transfer types for DATE */
typedef struct tagMDATE_STRUCT
{
  signed short year;
  unsigned short month;
  unsigned short day;
} MDATE_STRUCT;
#endif /*  !ACE_HAS_DATE_STRUCT */

typedef MBASE_INT32 mjdate;

EXTERN_C MExport
int mrleapyear (
    int year
);

EXTERN_C MExport
int mrmdyjul (
   short mdy[],
   mjdate* jdate
);

EXTERN_C MExport
int mrjulmdy (
   mjdate jdate,
   short mdy[]
);

EXTERN_C MExport
int mrdayofweek (
   mjdate jdate
);

EXTERN_C MExport
int mrtoday (
   mjdate* jdate
);

EXTERN_C MExport
int mrfmtdate (
   mjdate jdate,
   const char* fmt,
   char* to
);

EXTERN_C MExport
int mrfmtmdy (
   short mdy[],
   const char* fmt,
   char* to
);

EXTERN_C MExport
int mrdefmtdate (
   mjdate* jdate,
   const char* fmt,
   const char* s
);

EXTERN_C MExport
int mrdefmtmdy (
   short mdy[],
   const char* fmt,
   const char* s
);

EXTERN_C MExport
int mrdatestr (
  mjdate jdate,
  char* to
);

EXTERN_C MExport
int mrstrdate (
  const char* s,
  mjdate* jdate
);

EXTERN_C MExport
int mgetfmt ();

EXTERN_C MExport
int mrgetdefdatefmt (
   char* format
);


EXTERN_C MExport
int mfmtstr (
   char* fmt
);

#ifndef NO_INFORMIX_MAP

#define tagDATE_STRUCT tagMDATE_STRUCT
#define DATE_STRUCT MDATE_STRUCT

#define rleapyear mrleapyear
#define rmdyjul mrmdyjul
#define rjulmdy mrjulmdy
#define rdayofweek mrdayofweek
#define rtoday mrtoday
#define rfmtdate mrfmtdate
#define rfmtmdy mrfmtmdy
#define rdefmtdate mrdefmtdate
#define rdefmtmdy mrdefmtmdy
#define rdatestr mrdatestr
#define rstrdate mrstrdate
#define getfmt mgetfmt
#define rgetdefdatefmt mrgetdefdatefmt
#define fmtstr mfmtstr
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_RDATE_H__ */
