#include "mbase/process.h"
#include "mbase/rutils.h"

static int rmknexttemp (
   char* pn
)

{
   register char* to;

   for (to=&pn[2]; to>=pn; to--)
    {
      if ((*to)++<'z')
       return 0;
      *to = 'a';
    }
   return -1;
}

char* rbasename (
   char* fname
)

{
   register char* bn = 0;

   while (*fname!='\0')
     if (*fname++=='/')
      bn = fname - 1;
    
   return bn;
}

char* rmktemp (
   register char* fname
)

{
   register int pid;
   register char* to;
   char* pn;

   for (to = rbasename(fname); *to!='N'; to++);
   for (pn = to; *to=='N'; to++)
    *to = 'a';
   while (*to=='X') to++;
   to--;
   pid = getpid();
   do
    {
     *to-- = (pid % 10) + '0';
     pid = pid / 10;
    }
   while (*to=='X');
   while (access(fname, 0)!=-1)
    {
      if (rmknexttemp(pn)==-1)
       return 0;
    }

   return fname;
}
