#if !defined(__MBASE_SMALLINT_H__)
#define __MBASE_SMALLINT_H__
#include "mbase/config.h"

typedef short smallint;
#define mldshort(from) ((short)(((unsigned char*)(from))[0]<<8) + (((unsigned char*)(from))[1]&0xff))
#define mldushort(from) ((((unsigned char*)(from))[0]<<8) + (((unsigned char*)(from))[1]&0xff))
#define mstshort(s,to) (to)[0] = ((s)>>8)&0xff; (to)[1] = ((s)&0xff)

#define INTSIZE sizeof(smallint)

EXTERN_C MExport
int mrstoi (
   const char* buf,
   smallint *s
);

#ifndef NO_INFORMIX_MAP
#define rstoi mrstoi
#define ldshort mldshort
#define ldushort mldushort
#define stshort mstshort
#endif /* NO_INFORMIX_MAP */

#endif /* __MBASE_SMALLINT_H__ */
