#ifndef __MBASE_VSTRING_H__
#define __MBASE_VSTRING_H__
#include "mbase/config.h"

EXTERN_C
struct mvstring_s;

struct mvstring_s
{
   int maxlen;
   int len;
   char *data;
};
typedef struct mvstring_s *mvstring;

EXTERN_C MExport 
int mvstring_memcpy (
   mvstring vs,
   const char *from,
   int len
);

EXTERN_C MExport 
mvstring mvstring_assign (
   mvstring vs,
   const mvstring from
);

EXTERN_C MExport 
int mvstring_copy (
   mvstring vs,
   const char *from
);

EXTERN_C MExport 
void mvstring_realloc (
   mvstring vs,
   int newlen
);

EXTERN_C MExport 
mvstring mvstring_alloc (mvstring vs);

EXTERN_C MExport 
mvstring mvstring_alloc_from_string (
   mvstring vs,
   const char *from
);

EXTERN_C MExport 
mvstring mvstring_alloc_from_char (
   mvstring vs,
   char c
);

EXTERN_C MExport 
void mvstring_setnull (
   mvstring vs
);

EXTERN_C MExport 
void mvstring_free (
   mvstring vs
);

#endif /* __MBASE_VSTRING_H__ */
